﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AntData.ORM;
using AntData.ORM.Data;
using AntData.ORM.DataProvider.MySql;
using DbModels.Mysql;

namespace AntDataReadWriteDemo
{
    class Program
    {
        private static DbContext<Entitys> DB;
        static void Main(string[] args)
        {
            InitDB();

            var school = new School
            {
                Name = "上海大学",
                Address = "上海",
                DataChangeLastTime = DateTime.Now
            };

            //写操作走master
            var insertResult = DB.Insert(school);
            Debug.WriteLine(insertResult);

            //读操作从slaver
            var schools = DB.Tables.Schools.ToList();
            Debug.WriteLine(schools.Count);

            //在事物里面都走master
            DB.UseTransaction(con =>
            {
                //走Master
                con.Insert(school);

                //走Master
                var ss = con.Tables.Schools.ToList();
            });
        }

        private static void InitDB()
        {
            DB = new DbContext<Entitys>("testorm", new MySqlDataProvider());
            AntData.ORM.Common.Configuration.Linq.AllowMultipleQuery = true;
            AntData.ORM.Common.Configuration.Linq.IgnoreNullInsert = true;
            DB.IsEnableLogTrace = true;
            DB.OnLogTrace = OnCustomerTraceConnection;
        }

        private static void OnCustomerTraceConnection(CustomerTraceInfo customerTraceInfo)
        {
            try
            {
                string sql = customerTraceInfo.CustomerParams.Aggregate(customerTraceInfo.SqlText,
                       (current, item) => current.Replace(item.Key, item.Value.Value.ToString()));
                Debug.Write(sql + Environment.NewLine);
            }
            catch (Exception)
            {
                //ignore
            }
        }
    }
}
